--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer

local waterTowerTopRad = 128*FRACUNIT
local waterTowerTopNumSides = 5
local waterTowerRotSpeed = 32*ANG1

local waterSpinnerRadius = 180*FRACUNIT
local waterSpinnerKingSquidAttackVel = 4*FRACUNIT
local waterSpinnerKingSquidSpeed = 20*FRACUNIT/100
local waterSpinnerKingSquidAccel = 200*FRACUNIT/100
local waterPuddleNumIters = 16

local XIF_POWERITEM = 1 --is power item
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_UNIQUEANDUSED = 8 --same as unique, but also checks item timers (vanilla hyu specific: check hyubgone)
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --set hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount

local fWaterSpinnerRadius = CV_RegisterVar({ --override for the radius of the water spinner
	name = "elemental_water_spinsize",
	defaultvalue = "166.6",
	flags = CV_NETVAR|CV_FLOAT,
	possiblevalue = CV_Natural
})

local dWaterSpinnerAddCost = CV_RegisterVar({ --added timer cost for using water spinner
	name = "elemental_water_extracost",
	defaultvalue = "0",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})

local dWaterSpinnerHoldTics = CV_RegisterVar({ --extra time the waterspinner stays at max size
	name = "elemental_water_holdtics",
	defaultvalue = "4",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})

freeslot(
	"MT_ELEMBUKIWATER_TOP",
	"MT_ELEMBUKIWATER_TOPCORE",
	"MT_ELEMBUKIWATER_DROP",
	
	"S_ELEMBUKIWATER_TOPA",
	"S_ELEMBUKIWATER_TOPB",
	"S_ELEMBUKIWATER_TOPC",
	"S_ELEMBUKIWATER_TOPD",
	"S_ELEMBUKIWATER_TOPE",
	"S_ELEMBUKIWATER_PUDDLE",
	"S_ELEMBUKIWATER_DROP",
	
	"SPR_ELMW",
	
	"sfx_elmwst",
	"sfx_elmwus",
	"sfx_elmwfi",
	"sfx_elmwht",
	"sfx_elmwpb"
)

mobjinfo[MT_ELEMBUKIWATER_TOP] = {
	doomednum = -1,
    spawnstate = S_ELEMBUKIWATER_TOPA,
    spawnhealth = 9000,
    radius = 32*FRACUNIT,
    height = 64*FRACUNIT,
    flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP,
	flags2 = MF2_DONTDRAW
}

mobjinfo[MT_ELEMBUKIWATER_TOPCORE] = {
	doomednum = -1,
    spawnstate = S_INVISIBLE,
    spawnhealth = 9000,
    radius = 32*FRACUNIT,
    height = 64*FRACUNIT,
    flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP
}

mobjinfo[MT_ELEMBUKIWATER_DROP] = {
        doomednum = -1,
        spawnstate = S_ELEMBUKIWATER_DROP,
        spawnhealth = 9999,
        radius = 16*FRACUNIT,
        height = 8*FRACUNIT,
        flags = MF_SCENERY
}

states[S_ELEMBUKIWATER_TOPA] = {
        sprite = SPR_ELMW,
        frame = FF_TRANS20|FF_PAPERSPRITE|A,
        tics = -1,
		nextstate = S_ELEMBUKIWATER_TOPA,
}

states[S_ELEMBUKIWATER_TOPB] = {
        sprite = SPR_ELMW,
        frame = FF_TRANS20|FF_PAPERSPRITE|B,
        tics = -1,
		nextstate = S_ELEMBUKIWATER_TOPB,
}

states[S_ELEMBUKIWATER_TOPC] = {
        sprite = SPR_ELMW,
        frame = FF_TRANS20|FF_PAPERSPRITE|C,
        tics = -1,
		nextstate = S_ELEMBUKIWATER_TOPC,
}

states[S_ELEMBUKIWATER_TOPD] = {
        sprite = SPR_ELMW,
        frame = FF_TRANS20|FF_PAPERSPRITE|D,
        tics = -1,
		nextstate = S_ELEMBUKIWATER_TOPD,
}

states[S_ELEMBUKIWATER_TOPE] = {
        sprite = SPR_ELMW,
        frame = FF_TRANS20|FF_PAPERSPRITE|E,
        tics = -1,
		nextstate = S_ELEMBUKIWATER_TOPE,
}

states[S_ELEMBUKIWATER_PUDDLE] = {
        sprite = SPR_ELMW,
        frame = FF_PAPERSPRITE|F,
        tics = TICRATE,
		nextstate = S_NULL,
}

states[S_ELEMBUKIWATER_DROP] = {
        sprite = SPR_ELMW,
        frame = FF_TRANS10|FF_PAPERSPRITE|G,
        tics = -1,
		nextstate = S_NULL,
}

sfxinfo[sfx_elmwpb] = {
        singular = false,
        priority = 64,
        flags = SF_NOMULTIPLESOUND
}

local function AT_flerp(num, denum, minimum, maximum)
	local p = FixedDiv(num, denum)
	local a = FixedMul((maximum - minimum), p)
	local v = minimum + a
	return v
end

local function spawnWaterTrail(user)
	local i = 0
	while i < 2 do
		local travelangle = user.angle
		local newx = user.x + P_ReturnThrustX(user, travelangle + ((i==1) and -1 or 1)*90*ANG1, FixedMul(24*FRACUNIT, user.scale))
		local newy = user.y + P_ReturnThrustY(user, travelangle + ((i==1) and -1 or 1)*90*ANG1, FixedMul(24*FRACUNIT, user.scale))
		local dust = P_SpawnMobj(newx, newy, user.z, MT_THOK)
		dust.state = S_FASTDUST1
		dust.target = user
		dust.angle = travelangle - ((i==1) and -1 or 1)*15*ANG1
		dust.destscale = user.scale
		P_SetScale(dust, user.scale)

		dust.momx = user.momx
		dust.momy = user.momy
		--dust.momz = 3*user.momz/5

		K_MatchGenericExtraFlags(dust, user)
		dust.color = SKINCOLOR_BLUEBERRY
		dust.colorized = true
		
		i = $+1
	end
end

local function spawnWaterSpinner(user)
	local work = P_SpawnMobj(user.x, user.y, user.z + 32*FRACUNIT, MT_ELEMBUKIWATER_TOPCORE)
	work.initialized = false
	work.tracer = user
	K_MatchGenericExtraFlags(work, user)
end

local function spawnPuddlePart(user, iter, scale)
	local base = (FixedDiv(iter*FRACUNIT, (waterPuddleNumIters)*FRACUNIT/2)-FRACUNIT)
	local dist = FixedMul(FixedMul((16 - 10)*FRACUNIT, FixedMul(base,base)), FixedMul(user.scale, scale))
	
	local travelangle = R_PointToAngle2(0, 0, user.momx, user.momy)
	
	local newx = user.x + P_ReturnThrustX(user, travelangle + 180*ANG1, FixedMul((iter)*9*FRACUNIT/4, FixedMul(user.scale, scale))) + P_ReturnThrustX(user, travelangle + 90*ANG1, FixedMul(dist, FixedMul(user.scale, scale)))
	local newy = user.y + P_ReturnThrustY(user, travelangle + 180*ANG1, FixedMul((iter)*9*FRACUNIT/4, FixedMul(user.scale, scale))) + P_ReturnThrustY(user, travelangle + 90*ANG1, FixedMul(dist, FixedMul(user.scale, scale)))
	
	local work = P_SpawnMobj(newx, newy, user.z, MT_THOK)
	work.state = S_ELEMBUKIWATER_PUDDLE
	work.angle = travelangle + 90*ANG1
	work.scale = FixedMul(user.scale, scale)
	K_DoPogoSpring(work, -FRACUNIT/3, 0)
	K_MatchGenericExtraFlags(work, user)
	
	newx = user.x + P_ReturnThrustX(user, travelangle + 180*ANG1, FixedMul((iter)*9*FRACUNIT/4, FixedMul(user.scale, scale))) + P_ReturnThrustX(user, travelangle + 90*ANG1, FixedMul(-dist, FixedMul(user.scale, scale)))
	newy = user.y + P_ReturnThrustY(user, travelangle + 180*ANG1, FixedMul((iter)*9*FRACUNIT/4, FixedMul(user.scale, scale))) + P_ReturnThrustY(user, travelangle + 90*ANG1, FixedMul(-dist, FixedMul(user.scale, scale)))
	
	work = P_SpawnMobj(newx, newy, user.z, MT_THOK)
	work.state = S_ELEMBUKIWATER_PUDDLE
	work.angle = travelangle + (90+180)*ANG1
	work.scale = FixedMul(user.scale, scale)
	K_DoPogoSpring(work, -FRACUNIT/3, 0)
	K_MatchGenericExtraFlags(work, user)
end

local function spawnPuddle(user, scale)
	local i = 0
	while i < waterPuddleNumIters do
		spawnPuddlePart(user, i, scale)
		i = $ + 1
	end
end

local function spawnFinishExplode(mo)	--copy of my older splat explosions without the hitbox
	for i = 0, 8
		local d = P_SpawnMobj(mo.x, mo.y, mo.z+32*mapobjectscale, MT_ELEMBUKIWATER_DROP)
		d.angle = (ANG1*(360/8))*i
		d.scale = FRACUNIT
		P_InstaThrust(d, d.angle, 12*(mapobjectscale))
		P_SetObjectMomZ(d, 5+((i-4)/4)*FRACUNIT)
		d.momx = $ + mo.momx
		d.momy = $ + mo.momy
		--d.momz = $ + mo.momz
	end
end

local function checkWaterSpinnerPlayers(mo, radius)
	for p in players.iterate do
		if p.mo and p.mo.valid then
			if p.health == 0 then continue end
			if p.mo == mo.tracer then continue end
			local dist = R_PointToDist2(0, mo.z, R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y), p.mo.z)	--three dee
			if dist <= radius then
				K_SpinPlayer(p, mo, 1, mo.tracer, false)
			end
		end
	end
end

addHook("MobjThinker", function(mo)
	if mo.valid then
		if not mo.initialized then
			local lastwork = mo
			local work
			local i = 0
			while i < waterTowerTopNumSides do
				work = P_SpawnMobj(mo.x, mo.y, mo.z, MT_ELEMBUKIWATER_TOP)
				work.state = S_ELEMBUKIWATER_TOPA + i
				work.hprev = lastwork
				work.tracer = mo
				work.cylOffset = i
				lastwork = work
				i = $+1
				K_MatchGenericExtraFlags(work, mo.tracer)
			end
			mo.hprev = work
			mo.initialized = true
			mo.scaleAdjust = 0
			mo.scaleFrames = TICRATE/2
		end
		if mo.scaleFrames > -(dWaterSpinnerHoldTics.value) then
			if mo.scaleFrames >= 0 then
				mo.scaleAdjust = AT_flerp(mo.scaleFrames, TICRATE/2, FixedDiv(fWaterSpinnerRadius.value, waterTowerTopRad), 0)
				local checkrad = AT_flerp(mo.scaleFrames, TICRATE/2, FixedMul(fWaterSpinnerRadius.value, mo.tracer.scale), 4*FixedMul(fWaterSpinnerRadius.value, mo.tracer.scale)/5)
				checkWaterSpinnerPlayers(mo, checkrad)
				P_RadiusAttack(mo, mo, checkrad, DMG_WATER, false)
			else
				mo.scaleAdjust = FixedDiv(fWaterSpinnerRadius.value, waterTowerTopRad)
				local checkrad = FixedMul(fWaterSpinnerRadius.value, mo.tracer.scale)
				checkWaterSpinnerPlayers(mo, checkrad)
				P_RadiusAttack(mo, mo, checkrad, DMG_WATER, false)
			end
		else
			mo.scaleAdjust = AT_flerp(abs(mo.scaleFrames + (dWaterSpinnerHoldTics.value)), TICRATE/4, FixedDiv(fWaterSpinnerRadius.value, waterTowerTopRad), 0)
		end
		--speen
		mo.angle = $ - waterTowerRotSpeed
		mo.scale = FixedMul(mo.scaleAdjust, mo.tracer.scale)
		P_TeleportMove(mo, mo.tracer.x, mo.tracer.y, mo.tracer.z + 32*FRACUNIT)
		mo.scaleFrames = $-1
		
		if mo.scaleFrames == -TICRATE/4 - (dWaterSpinnerHoldTics.value) then
			P_RemoveMobj(mo)
		end
	end
end, MT_ELEMBUKIWATER_TOPCORE)

addHook("MobjThinker", function(mo)
	if mo.valid and mo.tracer and mo.tracer.valid then
		mo.scale = mo.tracer.scale
		local cX = mo.tracer.x + P_ReturnThrustX(mo, mo.tracer.angle + (360 * (ANG1 / waterTowerTopNumSides)) * mo.cylOffset, FixedMul(waterTowerTopRad, mo.tracer.scale))
		local cY = mo.tracer.y + P_ReturnThrustY(mo, mo.tracer.angle + (360 * (ANG1 / waterTowerTopNumSides)) * mo.cylOffset, FixedMul(waterTowerTopRad, mo.tracer.scale))
		P_TeleportMove(mo, cX, cY, mo.tracer.z)
		mo.momx = mo.tracer.momx	--(mo.tracer.x + mo.tracer.momx + P_ReturnThrustX(mo, mo.tracer.angle + waterTowerRotSpeed + (360 * (ANG1 / waterTowerTopNumSides)) * mo.cylOffset, FixedMul(waterTowerTopRad, mo.tracer.scale))) - cX
		mo.momy = mo.tracer.momy	--(mo.tracer.y + mo.tracer.momy + P_ReturnThrustY(mo, mo.tracer.angle + waterTowerRotSpeed + (360 * (ANG1 / waterTowerTopNumSides)) * mo.cylOffset, FixedMul(waterTowerTopRad, mo.tracer.scale))) - cY
		mo.momz = mo.tracer.momz
		mo.angle = mo.tracer.angle + (360 * (ANG1 / waterTowerTopNumSides)) * mo.cylOffset + 90*ANG1 --+ waterTowerRotSpeed
	end
	if (mo.tracer == nil) or (not mo.tracer) and (not mo.tracer.valid) then
		P_RemoveMobj(mo)
	end
end, MT_ELEMBUKIWATER_TOP)

addHook("MobjDeath", function(mo)
	if (mo.player and mo.valid) then
		local p = mo.player
		if p.elemAbilityW and p.elemAbilityW.inWater then
			mo.color = p.skincolor
			p.elemAbilityW.waterSpinnerTimer = 0
			p.elemAbilityW.waterSpinnerKingSquidAttackTimer = 0
		end
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	local p = mo.player
	if p.elemAbilityW and p.elemAbilityW.inWater then
		p.kartstuff[k_speedboost] = max($, waterSpinnerKingSquidSpeed)
		p.kartstuff[k_accelboost] = max($, waterSpinnerKingSquidAccel)
		p.kartstuff[k_boostpower] = max($, 0) --offroad reduction
		p.kartstuff[k_offroad] = 0 --offroad reduction
		
		if leveltime%2 == 0 and p.speed > 10*FRACUNIT and P_IsObjectOnGround(mo) then
			spawnPuddle(mo, FRACUNIT/3 + FixedMul(FRACUNIT, FixedDiv(p.speed, K_GetKartSpeed(p, false))))
		end
		if leveltime%5 == 0 and p.speed > 10*FRACUNIT and P_IsObjectOnGround(mo) then
			spawnWaterTrail(mo)
		end
		if leveltime%6 == 0 and p.speed > 10*FRACUNIT and P_IsObjectOnGround(mo) then
			S_StartSound(work, sfx_wdrip1 + (leveltime/6)%8)
		end
		mo.color = SKINCOLOR_AQUA + leveltime%6
		--K_SpawnSparkleTrail(mo)
		p.elemAbilityW.waterSpinnerTimer = $ - 1
		if p.elemAbilityW.waterSpinnerKingSquidAttackTimer then
			p.elemAbilityW.waterSpinnerKingSquidAttackTimer = $ - 1
		end
		if not (p.kartstuff[k_invincibilitytimer]) then
			if p.elemAbilityW.waterSpinnerTimer < 3*TICRATE and p.elemAbilityW.waterSpinnerTimer % 4 == 0 then
				mo.color = SKINCOLOR_BLUEBERRY
				mo.colorized = true
			else
				mo.colorized = false
			end
		end
		if p.elemAbilityW.waterSpinnerTimer < 0 then p.elemAbilityW.waterSpinnerTimer = 0 end
		if not p.elemAbilityW.waterSpinnerTimer then
			--print("end water buki")
			spawnFinishExplode(mo)
			p.kartstuff[k_itemamount] = $-1
			if p.kartstuff[k_itemamount] == 0 then
				p.kartstuff[k_itemtype] = 0
			end
			--p.kartstuff[k_itemheld] = 0 --fuck
			p.elemAbilityW.inWater = false
			mo.color = p.skincolor
			mo.colorized = false
			p.elemAbilityW.waterSpinnerKingSquidAttackTimer = 0
			S_StartSound(work, sfx_elmwfi)
			if p.health then
				K_PlayHitEmSound(mo)
			end
		end
	end
end, MT_PLAYER)

local function useWaterBuki(p, cmd)
	local mo = p.mo
	if not p.elemAbilityW then
		p.elemAbilityW = {
			inWater = false,
			waterSpinnerTimer = 0,
			waterSpinnerTimerMax = 24*TICRATE,
			waterSpinnerKingSquidAttackCost = TICRATE,
			waterSpinnerKingSquidAttackTimer = 0
		}
	end
	if not p.elemAbilityW.waterSpinnerTimer then
		--print("start water buki")
		p.elemAbilityW.waterSpinnerTimer = p.elemAbilityW.waterSpinnerTimerMax
		spawnWaterSpinner(mo)
		K_PlayPowerGloatSound(mo)
		S_StartSound(mo, sfx_elmwst)
		p.elemAbilityW.inWater = true
		--p.kartstuff[k_itemheld] = 1 --fuck
	elseif not p.elemAbilityW.waterSpinnerKingSquidAttackTimer then
		p.elemAbilityW.waterSpinnerTimer = $ - (p.elemAbilityW.waterSpinnerKingSquidAttackCost + dWaterSpinnerAddCost.value)
		if P_IsObjectOnGround(mo) or (mo.eflags & MFE_UNDERWATER) then
			K_DoPogoSpring(mo, waterSpinnerKingSquidAttackVel, 0)
			p.kartstuff[k_pogospring] = 1
		end
		p.elemAbilityW.waterSpinnerKingSquidAttackTimer = p.elemAbilityW.waterSpinnerKingSquidAttackCost
		spawnWaterSpinner(mo)
		K_PlayAttackTaunt(mo)
		S_StartSound(work, sfx_elmwus)
	end
end

local function waterBukiHud(v, p, c)
	local mo = p.mo
	if p.elemAbilityW and p.elemAbilityW.inWater then
		xItemLib.func.hudDrawItem(v, p, c, xItemLib.xItemNamespaces["XITEM_ELEMBUKI_WATER"], 2)
		p.xItemData.xItem_timerBar = p.elemAbilityW.waterSpinnerTimer or 0
		p.xItemData.xItem_maxTimerBar = p.elemAbilityW.waterSpinnerTimerMax
	else
		xItemLib.func.hudDrawItem(v, p, c, xItemLib.xItemNamespaces["XITEM_ELEMBUKI_WATER"])
	end
end

local function waterBukiOdds(newodds, pos, mashed, spbrush, p)
	if p.mo.skin ~= "elementa" then 
		return 0
	else
		return newodds
	end
end

if xItemLib then
	xItemLib.func.addItem{"XITEM_ELEMBUKI_WATER", "Aquanihilator", "K_ITWATR", "K_ISWATR", XIF_POWERITEM, {0, 0, 0, 1, 3, 5, 4, 2, 0, 0}, {4, 1}, nil, useWaterBuki, waterBukiHud, waterBukiOdds, nil, S_NULL}
end

--fuck
addHook("ThinkFrame", do
	for p in players.iterate do
		if p.mo and p.mo.skin ~= "elementa" and p.kartstuff[k_itemtype] == xItemLib.xItemNamespaces["XITEM_ELEMBUKI_WATER"] then 
			p.kartstuff[k_itemtype] = KITEM_GROW
			p.elemAbilityW = nil
		end
		if leveltime == 0 and p.elemAbilityW and p.elemAbilityW.inWater then
			p.elemAbilityW = nil
			mo.color = p.skincolor
			mo.colorized = false
		end
		if p.mo and p.mo.valid and p.health then
			if p.elemAbilityW and p.elemAbilityW.inWater then
				if p.elemAbilityW.waterSpinnerKingSquidAttackTimer then
					if p.elemAbilityW.waterSpinnerKingSquidAttackTimer >= (p.elemAbilityW.waterSpinnerKingSquidAttackCost - TICRATE/2) then
						K_SpawnSparkleTrail(p.mo)
						if not(p.kartstuff[k_pogospring])
							p.frameangle = $ + ANGLE_22h*leveltime
						end
						
						if not p.kartstuff[k_spinouttimer] then
							p.mo.frame = T
						end
					end
				end
			end
		end
	end
end)

addHook("TouchSpecial", function(s, t)
	if t.player and t.player.elemAbilityW and t.player.elemAbilityW.inWater then
		return true
	end
end, MT_EGGMANITEM)

addHook("TouchSpecial", function(s, t)
	if t.player and t.player.elemAbilityW and t.player.elemAbilityW.inWater then
		return true
	end
end, MT_EGGMANITEM_SHIELD)

addHook("ShouldDamage", function(target, inflictor, source)
	if inflictor and inflictor.valid and inflictor.type == MT_ELEMBUKIWATER_TOPCORE then
		if inflictor.tracer == target or source == target then
			return false
		end
	end
end, MT_PLAYER)

addHook("PlayerSpin", function(p, inflictor, source)
	if p.elemAbilityW and p.elemAbilityW.inWater then
		if p.elemAbilityW.waterSpinnerKingSquidAttackTimer >= (p.elemAbilityW.waterSpinnerKingSquidAttackCost - TICRATE/2) then
			S_StartSound(p.mo, sfx_elmwpb)
			K_DoInstashield(p)
			p.powers[pw_flashing] = 3
			return true
		end
	end
	if source and source.type == MT_ELEMBUKIWATER_TOPCORE and p.kartstuff[k_spinouttimer] <= (3*TICRATE/2)+1 then
		S_StartSound(p.mo, sfx_elmwht)
	end
end)

addHook("PlayerExplode", function(p, inflictor, source)
	if p.elemAbilityW and p.elemAbilityW.inWater then
		if p.elemAbilityW.waterSpinnerKingSquidAttackTimer >= (p.elemAbilityW.waterSpinnerKingSquidAttackCost - TICRATE/2) then
			S_StartSound(p.mo, sfx_elmwpb)
			K_DoInstashield(p)
			p.powers[pw_flashing] = 3
			return true
		end
	end
end)

addHook("PlayerSquish", function(p, inflictor, source)
	if p.elemAbilityW and p.elemAbilityW.inWater then
		if p.elemAbilityW.waterSpinnerKingSquidAttackTimer >= (p.elemAbilityW.waterSpinnerKingSquidAttackCost - TICRATE/2) then
			S_StartSound(p.mo, sfx_elmwpb)
			K_DoInstashield(p)
			p.powers[pw_flashing] = 3
			return true
		end
	end
end)

addHook("MobjThinker", function(mo)
	if mo.eflags & MFE_JUSTHITFLOOR then
		spawnPuddle(mo, FRACUNIT+FRACUNIT*(leveltime%5/3))
		P_RemoveMobj(mo)
	end
end, MT_ELEMBUKIWATER_DROP)